# hyper-volume of a 10-sphere of radii = 1.0
#  V = pi^5/5!

#from time import time
from random import random
from math import *

R = 1.0
V_ideal = pi**5/120 *R**10
print("10D-sphere\nPrecise vol =", V_ideal)

n = 4
total = n**10

FMT="N_points = {0}"+"x{0}"*9+" = {1}"
print(FMT.format(n, total))

# regular grid
#
dx = 2*R/n
Rs = -R+dx/2

#start1 = time()
def Regular():
    inside = 0
    for i1 in range(n):
        x1 = Rs+i1*dx
        for i2 in range(n):
            x2 = Rs+i2*dx
            for i3 in range(n):
                x3 = Rs+i3*dx
                for i4 in range(n):
                    x4 = Rs+i4*dx
                    for i5 in range(n):
                        x5 = Rs+i5*dx
                        for i6 in range(n):
                            x6 = Rs+i6*dx
                            for i7 in range(n):
                                x7 = Rs+i7*dx
                                for i8 in range(n):
                                    x8 = Rs+i8*dx
                                    for i9 in range(n):
                                        x9 = Rs+i9*dx
                                        for i10 in range(n):
                                            x10 = Rs+i10*dx

                                            a = x1**2+x2**2+x3**2+x4**2+x5**2+x6**2+x7**2+x8**2+x9**2+x10**2
                                            if a<=R**2:
                                                inside +=1
    p1 = inside/total
    V_eval1 = (2*R)**10 *p1
    error1  = abs(V_ideal-V_eval1)/V_ideal
    return V_eval1, p1, error1
#finish1 = time()


# Monte-Carlo
#
from functools import reduce

#start2 = time()
def MonteCarlo():
    inside = 0

    for k in range(total):
        x = [(2*random()-1)*R for i in range(10)]
        a = reduce(lambda a,b: a+b**2, x, 0)
        if a<=R**2:
            inside +=1
    p2 = inside/total
    V_eval2  = (2*R)**10 *p2
    error2  = abs(V_ideal-V_eval2)/V_ideal
    return V_eval2, p2, error2
#finish2 = time()

print("Regular:")
V_eval1, p1, error1 = Regular()
print("Volume      Error,%")
print("{:0.8G}   {:0.8G}%".format(V_eval1, error1*100))
#print("{:0.8G}   {:0.8G}   {:0.8G}".format(V_eval1, p1, error1))

print("Monte-Carlo:")
print("Volume      Error,%")
for i in range(10):
    V_eval2, p2, error2 = MonteCarlo()
    print("{:0.8G}   {:0.8G}%".format(V_eval2, error2*100))

##== run-1 ==
"""
10D-sphere
Precise vol = 2.550164039877345
N_points = 2x2x2x2x2x2x2x2x2x2 = 1024
Regular:
Volume      Error,%
0   100%
Monte-Carlo:
Volume      Error,%
1   60.786836%
2   21.573673%
4   56.852655%
1   60.786836%
5   96.065819%
3   17.639491%
2   21.573673%
2   21.573673%
1   60.786836%
2   21.573673%

10D-sphere
Precise vol = 2.550164039877345
N_points = 3x3x3x3x3x3x3x3x3x3 = 59049
Regular:
Volume      Error,%
0.43570594   82.914592%
Monte-Carlo:
Volume      Error,%
2.3931311   6.1577573%
2.583888   1.3224215%
2.3584481   7.5177898%
2.6359125   3.3624703%
2.2890819   10.237855%
2.583888   1.3224215%
2.5665464   0.64240525%
2.6359125   3.3624703%
2.5318634   0.71762725%
2.4971803   2.0776598%

10D-sphere
Precise vol = 2.550164039877345
N_points = 4x4x4x4x4x4x4x4x4x4 = 1048576
Regular:
Volume      Error,%
1   60.786836%
Monte-Carlo:
Volume      Error,%
2.5449219   0.20556187%
2.5722656   0.86667308%
2.5175781   1.2777968%
2.5371094   0.51191471%
2.5615234   0.44543792%
2.5449219   0.20556187%
2.5107422   1.5458556%
2.5644531   0.56032023%
2.6201172   2.7430842%
2.5507812   0.024202762%
"""
